import { Api } from './api';
import { Cache, HttpRequestOptions } from '@ztimson/utils';
import { Meta } from './core';
import { PathedEventEmitter } from './pathed-events';
export type Action = Meta & {
    name: string;
    trigger: {
        type: ActionType;
        value: string;
    };
    system?: boolean;
    fn: string;
    notes?: string;
    lastRun?: Date;
    lastRunLength?: number;
    nextRun?: Date;
};
export type ActionResponse = {
    action: string;
    stdout: any[];
    stderr: any[];
    return?: any;
};
export declare enum ActionType {
    'CRON' = 0,
    'EVENT' = 1,
    'DELETE' = 2,
    'GET' = 3,
    'PATCH' = 4,
    'POST' = 5,
    'PUT' = 6
}
export declare class Actions extends PathedEventEmitter {
    private readonly api;
    cache: Cache<string, Action>;
    constructor(api: Api | string);
    delete(id: string): Promise<void>;
    all(): Promise<Action[]>;
    read(id: string, reload?: boolean): Promise<Action | null>;
    run<T>(path: string, opts?: HttpRequestOptions): import('@ztimson/utils').PromiseProgress<T>;
    runById(action: string | Action, opts?: HttpRequestOptions): import('@ztimson/utils').PromiseProgress<ActionResponse>;
    update(action: Action): Promise<Action>;
}
//# sourceMappingURL=actions.d.ts.map