import { Http, HttpDefaults, HttpRequestOptions, PromiseProgress } from '@ztimson/utils';
import { IPathedEventEmitter } from './pathed-events';
export type Health = {
    status: 'offline' | 'ok' | 'degraded' | 'error';
    actions: HealthStatus;
    ai: HealthStatus;
    database: HealthStatus;
    email: HealthStatus;
    payments: HealthStatus;
    phone: HealthStatus;
    version: string;
    commit: string;
};
export type HealthStatus = 'disabled' | 'ok' | 'warn' | 'error';
export declare class Api extends Http implements IPathedEventEmitter {
    readonly url: string;
    readonly opts: HttpDefaults;
    private emitter;
    private pending;
    private _token;
    get token(): string | null;
    set token(token: string | null);
    constructor(url?: string, opts?: HttpDefaults);
    emit: (event: string | import('./pathed-events').PathEvent, ...args: any[]) => void;
    off: (listener: import('./pathed-events').Listener) => void;
    on: (event: string | string[], listener: import('./pathed-events').Listener) => import('./pathed-events').Unsubscribe;
    once: (event: string | string[], listener?: import('./pathed-events').Listener) => Promise<any>;
    relayEvents: (emitter: IPathedEventEmitter) => void;
    healthcheck(): PromiseProgress<any>;
    request<T>(options: HttpRequestOptions): PromiseProgress<T>;
}
//# sourceMappingURL=api.d.ts.map