import { Actions } from './actions';
import { Ai } from './ai';
import { Analytics } from './analytics';
import { Api } from './api';
import { Auth, AuthOptions } from './auth';
import { Data } from './data';
import { Email } from './email';
import { Groups } from './groups';
import { HttpRequestOptions } from '@ztimson/utils';
import { Logger, LogLevel } from './logger';
import { PathedEventEmitter } from './pathed-events';
import { Payments } from './payments';
import { Pdf } from './pdf';
import { Socket } from './sockets';
import { Storage } from './storage';
import { Client } from './client';
import { Users } from './users';
import { Settings } from './settings';
import { Static } from './static';
export type MomentumOptions = AuthOptions & {
    logLevel?: LogLevel;
    socket?: boolean;
    stripeSecret?: string;
    api?: HttpRequestOptions;
};
export declare class Momentum extends PathedEventEmitter {
    api: Api;
    actions: Actions;
    ai: Ai;
    analytics: Analytics;
    auth: Auth;
    client: Client;
    data: Data;
    email: Email;
    groups: Groups;
    logger: Logger;
    payments: Payments;
    pdf: Pdf;
    settings: Settings;
    socket?: Socket;
    static: Static;
    storage: Storage;
    users: Users;
    constructor(url?: string, opts?: MomentumOptions);
}
//# sourceMappingURL=momentum.d.ts.map